package it.unibas.acim2pinco.controllo;

import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import it.unibas.pinco.azioni.Azione;
import it.unibas.pinco.framework.Applicazione;
import it.unibas.acim2pinco.modello.*;
import it.unibas.acim2pinco.persistenza.DAOException;
import it.unibas.acim2pinco.persistenza.DAOProprietario;

public class AzioneConvalidaDatiProprietario implements Azione {
    
    private boolean richiestaCorretta(HttpServletRequest request) {
        HttpSession session = request.getSession();
        Utente utente = (Utente)session.getAttribute("utente");
        if (session.isNew() || utente == null || !utente.getRuolo().equals("amministratore")) {
            return false;
        }
        return true;
    }
    
    public String esegui(HttpServletRequest request){
        if (!richiestaCorretta(request)) {
            return "errore";
        }
        HttpSession session = request.getSession(false);
        Utente utente = (Utente)session.getAttribute("utente");
        ServletContext application = session.getServletContext();
        FormProprietario formProprietario = new FormProprietario();
        formProprietario.setNome(request.getParameter("nome"));
        formProprietario.setCodiceFiscale(request.getParameter("codiceFiscale"));
        formProprietario.setCittaDiResidenza(request.getParameter("cittaDiResidenza"));
        formProprietario.setAnnoPatente(request.getParameter("annoPatente"));
        List errori = formProprietario.convalida();
        if (errori.size() != 0) {
            request.setAttribute("formProprietario", formProprietario);
            request.setAttribute("errori", errori);
            return "erroriConvalida";
        }
        Proprietario proprietario = new Proprietario();
        proprietario.setNome(request.getParameter("nome"));
        proprietario.setCodiceFiscale(request.getParameter("codiceFiscale"));
        proprietario.setCittaDiResidenza(request.getParameter("cittaDiResidenza"));
        proprietario.setAnnoPatente(Integer.parseInt(request.getParameter("annoPatente")));
        try {
            DAOProprietario.doInsert(proprietario);
            request.setAttribute("proprietario", proprietario);
            return "successo";
        } catch (DAOException se) {
            Applicazione.logSevere("AzioneConvalidaDatiProprietario", "esegui", se.toString());
            return "errore";
        }
        
    }
}

