package it.unibas.acim2pinco.controllo;

import it.unibas.acim2pinco.modello.Utente;
import it.unibas.acim2pinco.persistenza.DAOAutomobile;
import it.unibas.acim2pinco.persistenza.DAOException;
import it.unibas.pinco.framework.Applicazione;
import it.unibas.pinco.azioni.Azione;
import java.util.Collection;
import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

public class AzioneStampaElenco implements Azione {
    
    private boolean richiestaCorretta(HttpServletRequest request) {
        HttpSession session = request.getSession();
        Utente utente = (Utente)session.getAttribute("utente");
        if (session.isNew() || utente == null) {
            return false;
        }
        return true;
    }
    
    public String esegui(HttpServletRequest request){
        if (!richiestaCorretta(request)) {
            return "errore";
        }
        HttpSession session = request.getSession(false);
        Utente utente = (Utente)session.getAttribute("utente");
        Collection elenco = null;
        try {
            elenco = DAOAutomobile.doSelectElencoProprietariEAutomobili();
            request.setAttribute("elenco", elenco);
            return "successo";
        } catch (DAOException se){
            Applicazione.logSevere("AzioneStampaElenco", "esegui", se + "");
            return "errore";
        }
    }
}

