package it.unibas.acim2pinco.persistenza;

import it.unibas.acim2pinco.modello.Utente;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

public class DAOUtente {

    public static Utente doSelectNomeUtente(String nomeUtente) throws DAOException {
        Utente utente = null;
        Connection connection = null;
        PreparedStatement statement = null;
        ResultSet resultSet = null;
        DataSource dataSource = DataSource.getInstance();
        try {
            connection = dataSource.getConnection();
            statement = connection.prepareStatement("select * from utenti where nomeutente = ?");
            statement.setString(1, nomeUtente);
            resultSet = statement.executeQuery();
            if (resultSet.next()){
                utente = new Utente();
                utente.setNomeUtente(resultSet.getString("nomeutente"));
                utente.setPassword(resultSet.getString("password"));
                utente.setNome(resultSet.getString("nome"));
                utente.setRuolo(resultSet.getString("ruolo"));
            }
        } catch (SQLException sqle) {
            throw new DAOException(sqle);
        } finally {
            dataSource.close(resultSet);
            dataSource.close(statement);
            dataSource.close(connection);
        }
        return utente;
    }

}



